// pages/index/rank/rank.js
import request from '../../../api/request.js'
import moment from 'moment';
Page({

    /**
     * 页面的初始数据
     */
    data: {
        rankList: [],
        dayTime: '',
        user: {
            id: '',
            userName: '',
            nickname: '',
            phone: "",
            token: "",
            headImg: ''
        },
        selfData: {
            id: 0,
            isOneSelf: 0,
            signDayNum: 0,
            signPercentage: "",
            signRecordNum: 0,
            userId: 0
        }
    },

    //排行榜列表
    getRankList() {
        request({
            url: `/wx/task/getSignRank`,
            method: 'post',
            data: {
                "page": 1,
                "pageSize": 999,
                "userId": wx.getStorageSync("userInfo_id")
            },
        }).then(res => {
            if (res.code == 0) {
                this.setData({
                    rankList: res.rows
                })
                console.log(this.data.rankList)
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },
    //去打卡
    toOpen() {
        wx.navigateTo({
            url: '/pages/index/index',
        })
    },
    //获取个人
    getSelf() {
        request({
            url: `/wx/task/getOneSelf`,
            method: 'get',
            data: {
                "userId": wx.getStorageSync("userInfo_id")
            },
        }).then(res => {
            if (res.code == 0) {
                this.setData({
                    selfData: res.data
                })
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                })
            }
        })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        
    },
    // 统一返回
    handleBack() {
        wx.navigateBack()
    },
    onShow() {
        this.setData({
            'user': wx.getStorageSync('userInfo')
        })
        this.setData({
            "dayTime": moment(new Date().getTime()).format('YYYY-MM-DD')
        })
        this.getSelf()
        this.getRankList()
    }
})