// pages/index/record/record.js
import request from '../../../api/request.js'
Page({

    /**
     * 页面的初始数据
     */
    data: {
        tabindex: 0,
        showAdd: false,
        taskList: [],

        tempList: [
            // {name:'自定义模板',url: '/img/answer/zdy.png'},
            // {name:'英语模板',url: '/img/answer/english.png'},
            // {name:'数学模板',url: '/img/answer/math.png'},
        ]
    },

    //打卡记录列表
    getTaskList() {
        request({
            url: `/wx/task/cardTaskList`,
            method: 'post',
            data: {
                "oneselfFlag": this.data.tabindex + 1,
                "page": 1,
                "pageSize": 999,
                "userId": wx.getStorageSync("userInfo_id")
            },
        }).then(res => {
            if (res.code == 0) {
                this.setData({
                    taskList: res.rows
                })
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },

    //模板列表
    getTempList() {
        request({
            url: `/wx/temp/tempList`,
            method: 'post',
            data: {},
        }).then(res => {
            if (res.code == 0) {
                this.setData({
                    tempList: res.data
                })
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },

    //打卡
    toShow(e) {
        this.getTempList()
        this.setData({
            showAdd: true
        })
    },
    //关闭
    closeAdd() {
        this.setData({
            showAdd: false
        })
    },
    //选择模板
    toPunch(e) {
        let obj = e.currentTarget.dataset
        let id = obj.value ? obj.value.id : 0
        wx.navigateTo({
            url: `../../index/newPunch/newPunch?tempId=${id}`
        })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        this.getTaskList()
    },
    //切换
    handleTab(e) {
        this.setData({
            tabindex: e.detail.index
        })
        this.getTaskList()
    },
    // 打卡成果
    handleAchievement(e) {
        wx.navigateTo({
            url: '/pages/index/achievement/achievement?valueId=' + e.currentTarget.dataset.valueid,
        })
    },
    // 去打卡
    handleDetail(e) {
        let eData = e.currentTarget.dataset
        wx.navigateTo({
            url: '/pages/index/punchDetail/punchDetail?valueId=' + eData.valueid,
        })
    },
    // 统一返回
    handleBack() {
        wx.navigateBack()
    },
    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})